---
title: Plugin: Goodix Fingerprint Sensor
---

## Introduction

The plugin used for update firmware for fingerprint sensors from Goodix.

## Firmware Format

The daemon will decompress the cabinet archive and extract a firmware blob in
a packed binary file format.

This plugin supports the following protocol ID:

* `com.goodix.goodixmoc`

## GUID Generation

These devices use the standard USB DeviceInstanceId values, e.g.

* `USB\VID_27C6&PID_6001`

## Update Behavior

The firmware is deployed when the device is in normal runtime mode, and the
device will reset when the new firmware has been written.

## Vendor ID Security

The vendor ID is set from the USB vendor, in this instance set to `USB:0x27C6`

## External Interface Access

This plugin requires read/write access to `/dev/bus/usb`.

## Version Considerations

This plugin has been available since fwupd version `1.5.0`.

## Owners

Anyone can submit a pull request to modify this plugin, but the following people should be
consulted before making major or functional changes:

* Boger Wang: @boger047
